#include <stdio.h>
#include <time.h>
#include <stdlib.h>

typedef double T;

int compare_T(const void* a, const void* b)
{
  T ai = *((T*)a), bi = *((T*)b);
  if(ai<bi)
    return -1;
  else if(ai>bi)
    return 1;
  else 
    return 0;
}

void test(int N)
{
  T* data;
  time_t begin, end;
  double time_elapsed;
  int i;

  if(N < 1)
  {
    printf("Input value %d too small.\n", N);
    return;
  }

  data = (T*) malloc(N*sizeof(T));
  if(!data)
  {
    printf("Could not allocate data - %d bytes.\n", N*sizeof(T));
    return;
  }
  for(i=0; i<N; ++i)
    data[i] = rand();

  begin = clock();
  qsort(data, N, sizeof(T), &compare_T);
  end = clock();
  time_elapsed = (double)(end-begin)/CLOCKS_PER_SEC;

  printf("%7.2lf\n", time_elapsed);
  free(data);
}

int main(int argc, char* argv[])
{
  int i;
  if(argc != 2)
    printf("Usage: %s <array-size>\n", argv[0]);
  else
  {
    for(i=0; i<10; ++i)
      test(atoi(argv[1]));
  }
  return 0;
}

