#include <time.h>
#include <stdlib.h>

#include <iostream.h>
#include <vector.h>
#include <algo.h>

typedef double T;

void test(int N)
{
  if(N < 1)
  {
    cerr << "Input value " << N << " too small." << endl;
    return;
  }

  vector<T> data(N);
  for(int i=0; i<N; ++i)
    data[i] = rand();

  time_t begin = clock();
  sort(data.begin(), data.end());
  time_t end = clock();
  double time_elapsed = double(end-begin)/CLOCKS_PER_SEC;

  cout << time_elapsed << endl;
}

int main(int argc, char* argv[])
{
  if(argc != 2)
    cerr << "Usage: " << argv[0] << "<array-size>" << endl;
  else
  {
    for(int i=0; i<10; ++i)
      test(atoi(argv[1]));
  }
  return 0;
}

