/* $Id$
 *
 * History:129,30
 *
 * $Author$
 * $Date$
 * $Revision$
 *
 * Copyright (C) 1995 Pragmatic Designs, All Rights Reserved
 *
 * $Log$
 *
 */

#define	MAIN

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <mem.h>

#include <fastgraf.h>
#include <fgfonts.h>

#include "struct.h"
#include "prototyp.h"


/****************************************************************
 * The default color palette.
 */
struct	_RGBpalette {
	char	R;
	char	G;
	char	B;
} RGBpalette[] = {
	{  0,  0,  0 },
	{  7, 15, 39 },
	{  9, 25, 49 },
	{  6, 42, 35 },
	{ 63, 63,  0 },
	{ 28, 32,  0 },
	{ 22, 26,  0 },
	{ 12, 21,  0 },
	{ 35, 30,  5 },
	{ 36, 35,  0 },
	{ 42,  0,  0 },
	{  0,  0,  0 },
	{ 21, 21, 21 },
	{ 30, 30, 30 },
	{ 41, 41, 41 },
	{ 63, 63, 63 }

};


/****************************************************************
 * Start of main function.
 */
int
main (int argc, char* argv[])
{
	int		level = 6;					// default level of influence
	iPoint	rv;
	Mouse	mouse;
	int		update = 0;

	unsigned char	key, aux;			// for fg_intkey

	/* Inz the SVGA card.
	 */
	fg_svgainit (0);
	fg_setmode (25);					// 640X480X256
	fg_resize (700, 736);

	fg_setdacs (0, 16, (char*) RGBpalette);

	fg_setcolor (TRANS);				// erase the screen
	fg_fillpage ();

	/* Parse the command line.
	 */
	if (argc >= 2) {
		level = atoi (argv[1]);
	}

	fg_mouseini ();						// setup the mouse

	/* Load the FGF font.
	 */
	if (fgf_load ("block05.fgf") == 0) {
		Error ("Unable to load BLOCK05.FGF.\n");
	}
	fgf_justify (0, -1);				// center, lower

	initScreenMap ();

	fg_setcolor (M_GRAY);
	drawGrid ();
	labelGrid ();

//	fg_makepcx (0, 639, 0, 479, "hex.pcx");

	fgShowCursor ();					// show the mouse...

	/* Main event loop.  Look for a mouse button press.
	 */
	do {
		fgMouseStat (&mouse);
		testPos (&mouse.loc);

		/* Check for left mouse button.
		 */
		if (fgTestButton (1, &mouse)) {
			if (pointInHex (&rv, &mouse.loc)) {
				fgHideCursor ();		// mouse off
				tstMap[rv.x][rv.y] = 1 - tstMap[rv.x][rv.y];
				outlineHex (&rv);
				update = 1;
				fgShowCursor ();		// mouse back on
			}
		}
		/* Check for right mouse button.
		 */
		if (fgTestButton (2, &mouse)) {
			if (pointInHex (&rv, &mouse.loc)) {
				fgHideCursor ();		// mouse off
				tstMap[rv.x][rv.y] = -1 - tstMap[rv.x][rv.y];
				outlineHex (&rv);
				update = 1;
				fgShowCursor ();		// mouse back on
			}
		}

		if (update) {
			calcInfluence (level);
			fgHideCursor ();
			showInfluence ();
			fgShowCursor ();
			update = 0;
		}
		fg_intkey (&key, &aux);
	} while (key != 27);				// ESCape key

	/* All finished, clean up and exit.
	 */
	fg_setpage (0);
	fg_setvpage (0);
	fg_mousefin ();						// unhook the mouse driver

	freeScreenMap ();

	fg_setmode (3);						// back to CO80
	fg_reset ();

	return 0;
}


/* EOF - $RCSfile$ */
