/* $Id$
 *
 * History:70,10
 *
 * $Author$
 * $Date$
 * $Revision$
 *
 * Copyright (C) 1995 Pragmatic Designs, All Rights Reserved
 *
 * $Log$
 *
 */
#ifndef	_STRUCT_H_
#define	_STRUCT_H_

/****************************************************************
 * An integer pair.  Useful as a screen vertex or an XY pair.
 */
typedef	struct	_iPoint {
	int		x;
	int		y;
} iPoint;

/****************************************************************
 * Your basic hexagon.
 */
typedef	struct	_Hex {
	iPoint	vertex[6];
} Hex;

/****************************************************************
 * The mouse structure.
 */
typedef	struct	_Mouse {
	iPoint	loc;						// last XY location
	int		status;
} Mouse;


/****************************************************************
 * The screen map structure.  This defines the center point of
 * each visible hexagon.
 */
typedef	struct	_scrnMap {
	iPoint	vertex;						// center point
	short	visible;					// is hex visible?

	iPoint	loc;						// hex label
} ScrnMap;

/****************************************************************
 * The bitmap icon location structure.  This holds the location of
 * the lower left corner of the bitmap.
 */
typedef	struct _iconMap {
	iPoint	loc;
} IconMap;

/****************************************************************
 * The game map structure
 */
typedef	struct _gameMap {
	iPoint	loc;						// hex ID
	short	visible;					// is this hex real?
	short	icon;						// ID of the underlying bitmap
} GameMap;


/****************************************************************
 * Enums.
 */
enum	 Color {						// Color names, 1st 16 colors
	TRANS,	D_BLUE,	L_BLUE,	GREEN,
	YELLOW,	UKN1,	UKN2,	UKN3,		// UKNs is for ground terrain
	UKN4,	UKN5,	RED,	BLACK,		// that can change.  TRANS is
	D_GRAY,	M_GRAY,	L_GRAY,	WHITE		// for transparent black.
};


#endif


/* EOF - $RCSfile$ */
