/* $Id$
 *
 * History:17,17
 *
 * $Author$
 * $Date$
 * $Revision$
 *
 * Copyright (C) 1995 Pragmatic Designs, All Rights Reserved
 *
 * $Log$
 *
 */

#include <fastgraf.h>

#include "struct.h"
#include "prototyp.h"


/****************************************************************
 * Global Data
 */
short		cursorLevel = 0;			// mouse cursor hidden flag


/****************************************************************
 * Hide the mouse cursor.  Each call to fgHideCursor should be
 * balanced by a call to fgShowCursor.
 */
void
fgHideCursor (void)
{
	cursorLevel--;
	fg_mousevis (0);
}


/****************************************************************
 * Show the mouse cursor.
 */
void
fgShowCursor (void)
{
	cursorLevel++;

	if (cursorLevel >= 0) {
		cursorLevel = 0;
		fg_mousevis (1);
	}
}


/****************************************************************
 * Test for a mouse button press.  Enter with the button to test
 * and a handle to store the resulting location in.  A flag is
 * returned indicating that the button was indeed pressed.
 */
int
fgTestButton (int button, Mouse* mouse)
{
	fg_mousebut (button, &mouse->status, &mouse->loc.x, &mouse->loc.y);
	return (mouse->status != 0);
}


/****************************************************************
 * Return the current mouse position and button status.
 */
void
fgMouseStat (Mouse* mouse)
{
	fg_mousepos (&mouse->loc.x, &mouse->loc.y, &mouse->status);
}


/* EOF - $RCSfile$ */
