//	World engine
// (C) 1997 Aurel Balmosan
#ifndef _GA_WorldClasses_H_
#define _GA_WorldClasses_H_

#include "general.h"
#include "geometry.h"

typedef float (*MapCombineFunc)(float a, float b);

class LevelMap
{         int   width;
          int   height;
          int   *value;
          int   **ptr;
          int   *map;
          Random rnd;

        public:
          const int fix_shift=14;
          const int fix1=(1<<14);
          const int fix_max=(1<<(30-fix_shift))-1;

          LevelMap() { width=height=0; value=map=NULL; ptr=NULL; }
          LevelMap(int w, int h);
          ~LevelMap();
          void SetSize(int w, int h);

          int Width() const { return width; }
          int Height() const { return height; }
          int& Value(int x, int y) { return ptr[y][x]; }

          void Generate(int iterations, int seed=0);
          void Generate(int iter, Point min, Point max, int seed=0);
          void Combine(const LevelMap *a, MapCombineFunc f);
          void Combine(MapCombineFunc f);
};
#endif
