from string import *
import re
import cgi
import REX
from proxy3_filter import *

# This needs to be performing some parsing to work right .. arggh!

#   URLs should not be modified
#   JavaScript should not be modified
#   Titles should not be modified
#   ALT text should not be modified
#   etc.

class _HighlightFilter(BufferSomeFilter):
    # This isn't exactly right .. it needs buffering, but the BufferSomeFilter
    # doesn't work the way we need it to.  We should be looking at the last
    # replacement from re.sub and using that to decide how much to write out
    def __init__(self, parent, next, length, keywords, **kw):
        apply(BufferSomeFilter.__init__, (self, parent, next, length), kw)
        self.keywords = keywords
        self.pattern = re.compile(r'(?i)\b(%s)\b' % join(keywords, '|'))
        self.in_script = 0
        self.in_style = 0
        self.in_head = 0
        
    def filter(self, s):
        parts = REX.ShallowParse(s)
        if not parts: return s
        output = []
        for part in parts[:-1]: # Everything but the last part
            maybe_tag = lower(part)
            if maybe_tag[:1] == '<':
                if maybe_tag[:7] == '<script': self.in_script = 1
                if maybe_tag[:8] == '</script': self.in_script = 0
                if maybe_tag[:6] == '<style': self.in_style = 1
                if maybe_tag[:7] == '</style': self.in_style = 0
                if maybe_tag[:5] == '<head': self.in_head = 1
                if maybe_tag[:6] == '</head': self.in_head = 0

            if (not self.in_script and not self.in_style
                and not self.in_head and maybe_tag[:1] != '<'):
                #print self.pattern.pattern, `part`
                while 1:
                    m = self.pattern.search(part)
                    if not m:
                        # If there are no keywords to highlight,
                        # save the rest and stop processing
                        output.append(part)
                        break
                    else:
                        # If there are keywords to highlight,
                        # highlight the first one, and continue
                        # processing with the rest of the string
                        output.append(part[:m.start(1)])
                        output.append('<font color=red><strong>%s'
                                      '</strong></font>' % m.group(1))
                        output.append(part[m.end(1):m.end()])
                        part = part[m.end():]
            else:
                # It's HTML, or script, or style
                output.append(part)

        # We've processed some of it, but not the last part
        return join(output, ''), parts[-1]

def HighlightFilter(parent, next, length, **kw):
    # This filter function optionally installs a filter into the chain,
    # so there's no overhead in most cases
    clientheaders = kw['clientheaders']
    url = kw['url']
    mimetype = kw['type']
    referer = clientheaders.getheader('Referer', '')
    if ((find(url, 'google.com') < 0 or find(url, 'cache:') >= 0)
        and find(referer, 'google.com') >= 0
        and mimetype == 'text/html'):
        # Look for keywords in the query string
        if find(referer, '?') >= 0:
            args = cgi.parse_qs(referer[find(referer, '?')+1:])
        elif find(referer, '/keyword/kwoff/') >= 0:
            args = cgi.parse_qs('q='+referer[15+find(referer, '/keyword/kwoff'):])
        else:
            args = None
            
        if args and args.has_key('q'):
            query = args['q'][0]
            keywords = filter(None, re.split(r'[^\w&]+', query))
            return apply(_HighlightFilter, (parent, next, length, keywords), kw)
    return next

register_filter('*', 'text/html', HighlightFilter)

