def event_process_request(obj, site, document, request, headers):
    if site != '_proxy':
        return None

    if document=='/headers':
        html_output(obj.outfile, '<PRE>' + join(headers.headers) + '</PRE>')
        return []
    
    if document=='/auto':
        from proxy3_web import PORT
        import proxy3_base
        host = proxy3_base.HOST
        try:
            if obj.address == lookup_name(host) or obj.address == '127.0.0.1':
                host = 'localhost'
        except socket.error:
            pass
        program = ('function FindProxyForURL(url, host) {\r\n'
                   'if (shExpMatch(url, "*.pdf") || shExpMatch(url, "*.ps") || shExpMatch(url, "*.zip") || shExpMatch(url, "*.gz"))'
                   '  return "DIRECT";\r\n' # Binary, probably large
                   'if (!shExpMatch(host, "*.*") &&'
                   ' !shExpMatch(host, "*_proxy*")) \r\n'
                   '  if(!shExpMatch(url, "http://*/?*")) \r\n'
                   '    // just a word, not a url really \r\n'
                   '    return "PROXY %(host)s:%(port)s; DIRECT";\r\n'
                   '  else\r\n'
                   '    // local host \r\n'
                   '    return "DIRECT";\r\n'
                   'if(shExpMatch(url,"http:*")||shExpMatch(url,"proxy:*"))\r\n'
                   '  return "PROXY %(host)s:%(port)s; DIRECT";\r\n'
                   'return "DIRECT";\r\n'
                   '}\r\n' % 
                   {'host':host, 'port':PORT})
        out = obj.outfile.write
        out('HTTP/1.0 200 Document follows\r\n')
        out('Content-type: application/x-ns-proxy-autoconfig\r\n')
        out('Content-length: '+`len(program)`+'\r\n')
        out('\r\n')
        out(program)
        return []
    
    if document=='/blocklist':
        s = '<h1>Patterns to block</h1>'
        for f in proxy3_block.Blocker.blocked:
            s = s + f + '<br>\r\n'
        html_output(obj.outfile, s)
        return []
    
    if document=='/filters':
        s = ('<h1>Filters in place</h1>'
             '<table><tr><th>URL</th><th>Mime Type</th><th>Action</th></tr>')
        for f in proxy3_filter.filter_table:
            try: name = ''+f[2].__name__
            except AttributeError: name = 'cancel filters'
            s = s + '<tr>'
            u = regex_to_glob(f[0].pattern)
            s = s + '<td><CODE>%s</CODE></td>' % u
            m = regex_to_glob(f[1].pattern)
            s = s + '<td><CODE>%s</CODE></td>' % m
            s = s + '<td><B>%s</B></td>' % name
            s = s + '</tr>'
        s = s + '</table>'
        html_output(obj.outfile, s)
        return []
    
    if document=='/location':
        from proxy3_web import PORT
        from proxy3_base import HOST
        html_output(obj.outfile, "%s %s" % (HOST, PORT))
        return []

from string import *
import socket
import proxy3_block, proxy3_filter
from proxy3_util import *
from proxy3_dns import lookup_name
