from string import *
from proxy3_filter import *
import proxy3_options

class SlashImageFilter(BufferSomeFilter):
    BUFFER_LEN = 128

    def filter(self, s):
        if not proxy3_options.options.get('blue-slashdot', 0): return s
        
        # For slc.gif, WHITE->GRAY
        s = replace(s, '\xfe\xfe\xfc', '\xe0\xe0\xe0')
        # For title.gif, SLASH->BLUE
        s = replace(s, '\x4e\x8c\x8c', '\x4e\x4e\x8c')
        s = replace(s, '\x0b\x4a\x45', '\x0b\x0b\x45')
        s = replace(s, '\x02\x66\x64', '\x02\x02\x64')
        s = replace(s, '\x06\x31\x33', '\x06\x06\x33')
        s = replace(s, '\x9d\xb2\xb4', '\x9d\x9d\xb4')
        s = replace(s, '\x6a\xa6\xa4', '\x6a\x6a\xa4')
        s = replace(s, '\x12\x5a\x55', '\x12\x12\x55')
        s = replace(s, '\x2e\x77\x77', '\x2e\x2e\x77')        
        return s
    
register_filter('yoda.blockstackers.com/*.gif', 'image/gif', SlashImageFilter)
register_filter('yoda.slashdot.org/*.gif', 'image/gif', SlashImageFilter)
register_filter('images.slashdot.org/*.gif', 'image/gif', SlashImageFilter)
