class Stats:
    ads_removed = 0
    cookies_received = 0
    cookies_sent = 0
    unix_errors = 0
    io_errors = 0

    sites_blocked = 0
    sites_visited = 0

def record(name):
    setattr(Stats, name, 1+getattr(Stats, name))

def event_site_blocked(address, site, document):
    record('sites_blocked')

def event_process_reply(obj, site, document, reply, headers):
    record('sites_visited')
    if headers.getheader('Set-Cookie'): record('cookies_received')

def event_process_request(obj, site, document, request, headers):
    if headers.getheader('Cookie'): record('cookies_sent')

def event_io_error(handler, err, context=''):
    record('io_errors')

def event_unix_error():
    record('unix_errors')

def event_ad_removed(url, tag):
    record('ads_removed')

def event_proxy_terminate():
    print ' ',Stats.sites_visited,'URLs allowed.'
    print ' ',Stats.sites_blocked,'URLs denied.'
    print ' ',Stats.ads_removed,'ads removed (not counting special sites).'
    print ' ',Stats.cookies_received,'cookies received.'
    print ' ',Stats.cookies_sent,'cookies sent.'
    print ' ',Stats.io_errors,'I/O errors (mostly broken pipes)'
    print ' ',Stats.unix_errors,'unix socket stupidities'

