from string import *
from proxy3_util import glob_to_regex
import proxy3_config

class Blocker:
    blocked = proxy3_config.get('block')
    nocookies = proxy3_config.get('nocookies')
    docookies = proxy3_config.get('docookies')
    
    def __init__(self):
	# Process the glob expressions, then compile into regexes
	# Store the regexes in the object, not the class

        self.blocked = map(glob_to_regex, Blocker.blocked)
        self.nocookies = map(glob_to_regex, Blocker.nocookies)
        self.docookies = map(glob_to_regex, Blocker.docookies)
        
    def matches_blocked(self, s):
	"""Returns 1 if the string matches one of the blocked sites"""
	for b in self.blocked:
	    if b.match(s) != None:
		return 1
	return 0

    def matches_nocookie(self, s):
	"""Returns 1 if the string matches one of the blocked sites"""
        if proxy3_options.options.get('accept-cookie-default', 1):
            for b in self.nocookies:
                if b.match(s) != None:
                    return 1
            return 0
        else:
            for b in self.docookies:
                if b.match(s) != None:
                    return 0
            return 1
        
# Define an instance of a global blocking variable
blocker = Blocker()
import proxy3_options
