from string import join, replace

event_handlers = {
    'idle': [],
    'status': [],
    'ad-removed': [],
    'site-blocked': [],
    'process-reply': [],
    'process-request': [],
    'io-error': [],
    'unix-error': [],
    'socket-error': [],
    'select-error': [],
    'kill-stale-handler': [],
    'unknown-request': [],
    'proxy-terminate': [],
    'extra-form-data': [],
    'time-connect': [],
    'time-handle': [],
    'time-name-lookup': [],
    'name-lookup-begin': [],
    'name-lookup-end': [],
}

def broadcast_event(name, *args):
    "Go through the event handlers and call each one"
    "If one returns non-None, abort event handling"
    handlers = event_handlers.get(name, [])
    for h in handlers:
        ret = apply(h, args)
        if ret is not None: return ret
    return None

def register_event(name, handler):
    existing_handlers = event_handlers.get(name, [])
    if handler not in existing_handlers:
	event_handlers[name] = existing_handlers + [handler]
	
def register_all(dict):
    "Read a dictionary mapping names to values, and register event_* names"
    # This is very useful for modules -- you can just define things in a
    # module and they'll get registered automatically
    for var in dict.keys():
	if var[:6]=='event_':
	    # It looks like an event, so register it
	    name = replace(var[6:], '_', '-')
	    register_event(name, dict[var])
