from string import *
import re


# These are the modules that the evaluated expression is allowed to access:
import cgi, urllib # For eval()
GLOBALS = {'cgi': cgi, 'urllib': urllib}

import proxy3_config
from proxy3_util import glob_to_regex

rewrites = []
for line in proxy3_config.get('rewrite'):
    fields = split(strip(line))
    if len(fields) == 2:
        frompat, topat = fields
        frompat = replace(frompat, '$URL', r'(?P<URL>\S+)') # .$?* not allowed
        frompat = glob_to_regex(frompat)
        rewrites.append( (frompat, topat) )
        
def rewrite_url(url):
    "Take a url (without http://), return None or a new url (without http://)"
    altered = 0
    while 1:
        for frompat, topat in rewrites:
            m = frompat.match(url)
            if m:
                altered = 1
                # Evaluate an expression, where URL is a variable
                # containing the matched URL, and the cgi module is available
                try: url = eval(topat, {'URL': m.group('URL')}, GLOBALS)
                except: return url # Don't try any more, because it failed
                if url[:7] == 'http://': url = url[7:]
                break
        else:
            if not altered: return None
            else: return url

